<?php
/*
  $Id: configurer.php,v 1.1 2014/07/07 00:00:00 $

  Designed for: osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2006-2014 Todd Holforty - mtholforty [at] surfalot [dot] com

  Released under the GNU General Public License
  
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

  require('includes/application_top.php');

  // set default timezone if none exists (PHP 5.3 throws an E_WARNING)
  if (version_compare(PHP_VERSION, '5.2', '>=') && !ini_get('date.timezone')) {
    date_default_timezone_set('America/New_York');
  }

  $action = (isset($HTTP_GET_VARS['action']) ? tep_db_prepare_input($HTTP_GET_VARS['action']) : '');
  $file_sub = (isset($HTTP_GET_VARS['conf']) ? tep_db_prepare_input($HTTP_GET_VARS['conf']) : '');
  
  require(DIR_WS_CLASSES . $file_sub . '_configurer.php');
  $conf = new configurer();

?><!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
    <title><?php echo TITLE; ?></title>
    <link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
    <script language="javascript" type="text/javascript" src="includes/general.js"></script>

	<style>
	  * {
		font-family: Verdana, Arial, sans-serif;
		font-size: 12px;
	  }
			
	  textarea {
		resize: none;  
		margin-left: 14px;
		font-size: 12px;
		font-family: "Courier New", Courier, monospace;
		background-color: #FFF;
		display: inline-block;
		white-space: nowrap;
		white-space: pre;
		width: 90%;
		overflow: auto;
		padding: 12px 10px 8px 10px;
		border: green solid 1px;
		-webkit-border-radius: 3px;
		   -moz-border-radius: 3px;
			    border-radius: 3px;
		-moz-box-shadow: 1px 1px 2px gray; /* CSS3 shadows */
		 -webkit-shadow: 1px 1px 2px gray;
			 box-shadow: 1px 1px 2px gray;
	  }
      textarea:focus { 
		-moz-box-shadow: 0 0px 3px #006600;
		 -webkit-shadow: 0 0px 3px #006600;
			 box-shadow: 0 0px 3px #006600;
		        outline: #006600;
	  }

	  /* remove textarea padding because of long standing bug */
	  @-moz-document url-prefix() {
		textarea { 
		  padding-bottom: 0;
		}
	  }
    </style>

  </head>
  <body bgcolor="#FFFFFF" onLoad="SetFocus();">
    <div id="spiffycalendar" class="text"></div>
<!-- header //-->
  <?php require(DIR_WS_INCLUDES . 'header.php'); ?>
<!-- header_eof //-->
<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>
    <td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="1" cellpadding="1" class="columnLeft">
<!-- left_navigation //-->
<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
<!-- left_navigation_eof //-->
    </table></td>
<!-- body_text //-->
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="2" cellpadding="2">
      <tr>
        <td width="100%" valign="top">
        <table border="0" width="100%" cellspacing="0" cellpadding="2">
          <tr>
            <td><table border="0" width="100%" cellspacing="0" cellpadding="0">
              <tr>
                <td class="pageHeading"><?php echo $conf->current_version['name'] . ' ' . 'v' . $conf->current_version['version'] . ' - ' . HEADING_TITLE; ?></td>
                <td class="pageHeading" align="right"><?php echo tep_draw_separator('pixel_trans.gif', 1, HEADING_IMAGE_HEIGHT); ?></td>
              </tr>
            </table></td>
          </tr>
          <tr>
           <td valign="top">
            <table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr class="dataTableHeadingRow">
                <td class="dataTableHeadingContent">&nbsp;</td>
              </tr>
            </table>
            <br />
    <?php
      
      
      if ($action == 'normal' || $action == 'force' || $action == 'displayonly') {
        // process updates
    
    
            ?>
            <table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr>
                <td class="smalltext" nowrap="nowrap">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td class="smalltext"><?php 
                
                if ($action == 'normal') {
                  echo TEXT_UPDATING_CONFIGURATION . '<br />';
                  echo $conf->db_configurer_update(CONFIGURER_PROCESS_UPDATES);
                } elseif ($action == 'force') {
                  echo TEXT_UPDATING_CONFIGURATION . '<br />';
                  echo $conf->db_configurer_update(CONFIGURER_REFRESH_CONFIG);
                } elseif ($action == 'displayonly') {
                  echo TEXT_DISPLAYING_CONFIGURATION . '<br />';
                  echo $conf->db_configurer_update(CONFIGURER_DISPLAY_UPDATES);
                }
                
                echo '<br /><br />' . '<a href="' .  tep_href_link(basename(__FILE__), 'conf='.$file_sub) . '">' . tep_image_button('button_back.gif', IMAGE_BACK) . '</a>' . '<br />'."\n";
                
                ?></td>
              </tr>
            </table>
            <?php
    
    
      } elseif ($action == 'uninstall') {
        // remove contribution settings
        
            ?>
            <table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr>
                <td class="smalltext" nowrap="nowrap">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td class="smalltext"><?php echo TEXT_REMOVING_CONFIGURATION; ?><br /><?php 
                  
                echo $conf->db_configurer_remove();
                echo '<br />' . '<a href="' .  tep_href_link(basename(__FILE__), 'conf='.$file_sub) . '">' . tep_image_button('button_back.gif', IMAGE_BACK) . '</a>' . '<br />'."\n";
    
                ?></td>
              </tr>
            </table>
            <?php
    
    
    
      } else {
        // default page / display update status
    
            ?>
            <table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr>
                <td class="smalltext" nowrap="nowrap">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td class="smalltext"><?php echo TEXT_CHECKING_CONFIGURATION_STATUS; ?><br /><br /><?php 
    
                $status = $conf->db_configurer_status();
                
                if ($conf->needs_update) {
                  echo '<font color="red" size="4"><strong>' . TEXT_DATABASE_REQUIRES_UPDATE . '</strong></font><br /><br />';
                } else {
                  echo '<font color="green" size="4"><strong>' . TEXT_DATABASE_IS_UP_TO_DATE . '</strong></font><br /><br />';
                }
                
                echo $conf->status_messages . '<br />';
                
                if ($conf->needs_update) {
                  echo tep_draw_form('process', basename(__FILE__), '', 'get', '') . 
                  tep_draw_hidden_field('conf', $file_sub) . tep_draw_hidden_field('action', 'normal') .
                  tep_hide_session_id() . '<br />' . tep_image_submit('button_run_configuration_utility.gif', TEXT_CONFIG_PROCESS, '') . '<br />' . 
                  '</form>';
                  echo tep_draw_form('process', basename(__FILE__), '', 'get', '') . 
                  tep_draw_hidden_field('conf', $file_sub) . tep_draw_hidden_field('action', 'displayonly') .
                  tep_hide_session_id() . '<br /><br />' . tep_image_submit('button_display_updates_only.gif', TEXT_SHOW_ME_UPDATES, '') . '<br />' . 
                  '</form>';
                }
                
                ?></td>
              </tr>
            </table>
            <?php
    
      } // end if ($action) {
    
    ?>
    
           </td>
    
    <?php
    
        $heading = array();
        $contents = array();
        switch ($action) {
          case 'process':
                $heading[] = array('text' => '<strong>' . TEXT_SELECT_TASK . '</strong>');
                $contents[] = array('text' => '<br /><br /><br />&nbsp;' . '<a href="' . tep_href_link(basename(__FILE__),'conf='.$file_sub) . '">' . tep_image_button('button_back.gif', IMAGE_BACK) . '</a>' . '<br /><br />'."\n");
            break;
    
          default:
                $heading[] = array('text' => '<strong>' . TEXT_SELECT_TASK . '</strong>');
                $contents[] = array('text' => tep_draw_form('process', basename(__FILE__), '', 'get', 'onsubmit="if(this.action[2].checked==true){if(confirm(\''.TEXT_UNINSTALL_CONFIRMATION.'\')){return confirm(\''.TEXT_UNINSTALL_CONFIRMATION2.'\');}else{return false;}}"') . tep_draw_hidden_field('conf',$file_sub) . 
                                              '<p>' . TEXT_CONFIG_PROCESS_DESCRIPTION . '</p>' . '<br />'."\n" . 
                                              '<font color="red"><strong>' . TEXT_DATABASE_REQUIRES_UPDATE_WARNING . '</strong></font><br /><br /><br />' . 
                                              (($action!='uninstall') ? '&nbsp;' . tep_draw_input_field( /* $name */ 'action', /* $value */ 'normal', /* $parameters */ 'checked id="normal"', /* $required */ false, /* $type */ 'radio', /* $reinsert */ false) . '<label for="normal" style="cursor:hand;cursor:pointer;">' . TEXT_NORMAL_SETUP . '</label><br />'."\n" : '' ) .
                                              ($conf->found_one ? '&nbsp;' . tep_draw_input_field( /* $name */ 'action', /* $value */ 'force', /* $parameters */ 'id="force"', /* $required */ false, /* $type */ 'radio', /* $reinsert */ false) . '<label for="force" style="cursor:hand;cursor:pointer;">' . TEXT_FORCE_REFRESH . '</label><br /><br />'."\n" : '' ) . 
                                              ($conf->found_one ? '&nbsp;' . tep_draw_input_field( /* $name */ 'action', /* $value */ 'uninstall', /* $parameters */ 'id="uninstall"', /* $required */ false, /* $type */ 'radio', /* $reinsert */ false) . '<label for="uninstall" style="cursor:hand;cursor:pointer;color:#FF0000;">' . TEXT_UNINSTALL . '</label><br />'."\n" : '' ) . 
                                              (($action!='uninstall') ? '<br /><br />&nbsp;' . tep_hide_session_id() . tep_image_submit('button_run_configuration_utility.gif', TEXT_CONFIG_PROCESS) . '<br />'."\n" : '' ) . 
                                              '<br /><br />'."\n" . 
                                              (!empty($action) ? '&nbsp;' . '<a href="' . tep_href_link(basename(__FILE__),'conf='.$file_sub) . '">' . tep_image_button('button_back.gif', IMAGE_BACK) . '</a>' . ' &nbsp; '."\n" : '') . 
                                              (!empty($conf->cancel_page) ? '&nbsp;' . '<a href="' . tep_href_link($conf->cancel_page) . '">' . tep_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>' . '<br />'."\n" : '') . 
                                              '<br />'."\n" . 
                                              '</form>');
            break;
    
        }
    
        if ( (tep_not_null($heading)) && (tep_not_null($contents)) ) {
          echo '            <td width="25%" valign="top">' . "\n";
    
          $box = new box;
          echo $box->infoBox($heading, $contents);
    
          echo '            </td>' . "\n";
        }
    ?>
    
          </tr>
        </table></td>
      </tr>
    </table></td>
<!-- body_text_eof //-->
  </tr>
</table>
<!-- body_eof //-->

<!-- footer //-->
<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
<!-- footer_eof //-->
<br>
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>
