<?php
/*
  $Id: configurer.php,v 1.1 2014/07/07 00:00:00 $

  Designed for: osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  @author Todd Holforty <mtholforty [at] surfalot [dot] com>
  @copyright 2006-2014 Todd Holforty
  @license http://opensource.org/licenses/GPL-3.0 GNU General Public License, version 3.0 (GPLv3)

  Released under the GNU General Public License
  
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

require_once(DIR_FS_ADMIN . DIR_WS_LANGUAGES . $language . '/configurer.php');

// functionality constants
define('CONFIGURER_CHECK_STATUS', 1);
define('CONFIGURER_DISPLAY_UPDATES', 2);
define('CONFIGURER_PROCESS_UPDATES', 3);
define('CONFIGURER_REFRESH_CONFIG', 4);

//
//
// compatibility functions.
//
if ( !defined('MYSQLI_ASSOC') ) {
    define('MYSQLI_ASSOC', MYSQL_ASSOC);
}

if ( !defined('MYSQLI_BOTH') ) {
    define('MYSQLI_BOTH', MYSQL_BOTH);
}

if ( !defined('MYSQLI_NUM') ) {
    define('MYSQLI_NUM', MYSQL_NUM);
}

/*if ( !function_exists('mysqli_result') ) {
    function mysqli_result($res,$row,$field) {
        tep_db_data_seek($res, $row);
		if ($data = mysqli_fetch_array($res, MYSQLI_NUM)) {
          return $data[$field];
		}
        return false;
    }
}*/


  /**
   * Class contains data and functions to configure the osCommerce
   * database for this contribution.
   * 
   * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
   */
  class configurer {

	// //////////////////////////////////
    // BEGINNING OF USER CONFIGURATION
	// //////////////////////////////////

    // change this var to the page the cancel button will go to. 
	// for no cancel button, set to empty string ""
	var $cancel_page = FILENAME_CONTRIB_TRACKER;


    //
    // the name and current version of this contribution
    // //////////////////////////////////////////////////////////////////////////
    var $current_version = 
          array( 'name' => 'Contribution Tracker',
                 'version' => '1.8.0',
                 'configuration_key' => 'CONTRIB_TRACKER_VERSION' );



    //
    // define Configuration Groups and Configuration Items
    // //////////////////////////////////////////////////////////////////////////
    var $configuration_array = array (
  
          1 => array ( 
            'group' => array ( 'id' => 6,  // optional, if 0 or excluded, code will select next higher ID
                               'configuration_group_title' => 'Module Options',
                               'configuration_group_description' => 'Hidden from configuration',
                               'sort_order' => 6,  // optional, if 0 or excluded, code will select next higher ID
                               'visible' => 0 ),
            'data'  => array (
                       'LAST_CONFIG_CHECK' => array ( 
                               'configuration_title' => 'Last Contrib Check',
                               'configuration_value' => 'now()',
                               'configuration_description' => 'Last time checked the osCommerce official contribution site.',
                               'sort_order' => 0,  // optional, if 0 or excluded, code will select next higher ID
                               'use_function' => NULL,
                               'set_function' => NULL ),
                       'CONTRIB_TRACKER_VERSION' => array ( 
                               'configuration_title' => 'Contribution Tracker Version',
                               'configuration_value' => '0',
                               'configuration_description' => 'The version of the Contribution Tracker that is installed.',
                               'sort_order' => 0,  // optional, if 0 or excluded, code will select next higher ID
                               'use_function' => NULL,
                               'set_function' => NULL )  /*  ,
                       'CONFIGURATION_KEY' => array (
                               'configuration_title' => '',
                               'configuration_value' => '',
                               'configuration_description' => '',
                               'sort_order' => 0,  // optional, if 0 or excluded, code will select next higher ID
                               'use_function' => NULL,
                               'set_function' => NULL )    */
                       )
          ),  // end: group 1

          2 => array ( 
            'group' => array ( 'id' => 12,  // optional, if excluded, code will select next higher ID
                               'configuration_group_title' => 'E-Mail Options',
                               'configuration_group_description' => 'General setting for E-Mail transport and HTML E-Mails',
                               'sort_order' => 12,  // optional, if 0 or excluded, code will select next higher ID
                               'visible' => 1 ),
            'data'  => array (
                       'CONTRIB_TRACKER_NOTIFICATION' => array ( 
                               'configuration_title' => 'Contrib Tracker Notification email',
                               'configuration_value' => 'false',
                               'configuration_description' => 'Send Contrib Tracker notifications to store owner.',
                               'sort_order' => 4815,  // optional, if 0 or excluded, code will select next higher ID
                               'use_function' => NULL,
                               'set_function' => 'tep_cfg_select_option(array(\'true\', \'false\'),' )  /*  ,
                       'CONFIGURATION_KEY' => array (
                               'configuration_title' => '',
                               'configuration_value' => '',
                               'configuration_description' => '',
                               'sort_order' => 0,  // optional, if 0 or excluded, code will select next higher ID
                               'use_function' => NULL,
                               'set_function' => NULL )    */
                       )
          )  // end: group 2
		  
    );  // end: var $configuration_array



    //
    // define tables to create
    // //////////////////////////////////////////////////////////////////////////
    var $tables_array = array(
          1 => array ( 
            'tablename' => 'contrib_tracker',
            'create' => "CREATE TABLE `contrib_tracker` (
                                          contr_id int(11) NOT NULL auto_increment,
                                          contrib_osc_id int( 6 ) NOT NULL, 
                                          contrib_name varchar(255) NOT NULL default '',
                                          contrib_link varchar(255) default '',
                                          config_comments longtext,
                                          status tinyint(1) NOT NULL default '2',
                                          note_created datetime NOT NULL default '0000-00-00 00:00:00',
                                          contr_last_modified datetime NOT NULL default '0000-00-00 00:00:00',
                                          last_update datetime NOT NULL default '0000-00-00 00:00:00',
                                          status_reference_date datetime NOT NULL default '0000-00-00 00:00:00',
                                          contrib_vers varchar(12) default '',
                                          contrib_support VARCHAR(255) NULL,
                                          KEY config_id (contr_id)
                                        );",
            'insert' => array ( "INSERT INTO contrib_tracker (contrib_osc_id, contrib_name,contrib_link, contrib_support, config_comments, status, last_update, note_created, contr_last_modified, contrib_vers) VALUES ('9030','Contribution Tracker Now Installed','http://addons.oscommerce.com/info/9030', 'http://forums.oscommerce.com/index.php?showtopic=247157', 'Congratulations! Contribution Tracker now installed! You may now delete this Contribution or use it to play around with and get the feel of your new osC contribution.', 1, '2014-06-06', now(), '2014-06-06', '1.8.0');"
                               ),
            'remove' => "DROP TABLE IF EXISTS `contrib_tracker`;"
            ) /* , // end: table 1
            
          2 => array ( 
            'tablename' => 'new_table',
            'create' => "CREATE TABLE new_table (
                                          new_table_id int(11) NOT NULL auto_increment,
                                          new_table_int_field int( 6 ) NOT NULL, 
                                          new_table_varchar_field varchar(255) NOT NULL default '',
                                          KEY table_id (new_table_id)
                                        ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;",
            'insert' => array ( "INSERT INTO new_table (new_table_int_field, new_table_varchar) VALUES ('1234', 'Info1');",
                                "INSERT INTO new_table (new_table_int_field, new_table_varchar) VALUES ('1235', 'Info2');"
                               ),
            'remove' => "DROP TABLE IF EXISTS new_table;"
            )  // end: table 2   */
			
    );  // end: var $tables_array



    //
    // this array is used for altering existing tables, or contribution tables that have changed.
    // //////////////////////////////////////////////////////////////////////////
    var $table_columns_array = array(
          1 => array ( 
            'tablename' => 'contrib_tracker',
                           'columnname' => 'status_reference_date',
                           'create' => "ALTER TABLE `contrib_tracker` ADD `status_reference_date` DATETIME  NOT NULL  DEFAULT '0000-00-00 00:00:00'  AFTER `last_update` ;",
                           'remove' => "ALTER TABLE `contrib_tracker` DROP `status_reference_date`"
                      )/*  ,  // end: column 1
          2 => array ( 
            'tablename' => 'the_table',
                           'columnname' => 'the_table_new_column',
                           'create' => "ALTER TABLE the_table ADD the_table_new_column VARCHAR(64) default NULL AFTER the_table_exist_column;",
                           'remove' => "ALTER TABLE the_table DROP the_table_new_column"
                      )  // end: column 2   */
					  
    );  // end: var $table_columns_array


    //
    // define version updates
	// configurer will install all updates that are greater than
	// the installed version number and less than or equal to the 
	// current version number defined above in $current_version[].
    // //////////////////////////////////////////////////////////////////////////
    var $version_updates = array(
          '1.8.0' => array ( 
                  // drop table from previous versions that is no longer necessary
                  1 => "DROP TABLE IF EXISTS `date_status_change`;",
                  // increase contrib_support column size to 255 to support longer support URLs
                  2 => "ALTER TABLE  `contrib_tracker` CHANGE  `contrib_support`  `contrib_support` VARCHAR(255);",
                  // increase contrib_support column size to 255 to support longer support URLs
                  3 => "ALTER TABLE  `contrib_tracker` CHANGE  `contrib_vers`  `contrib_vers` VARCHAR(12);",
                  // copy current reference dates to new column
                  4 => "UPDATE `contrib_tracker` SET `status_reference_date` = `last_update`;",
                  // copy zero contr_last_modified to new column
                  5 => "UPDATE `contrib_tracker` SET `status_reference_date` = `contr_last_modified` where contr_last_modified = '0000-00-00 00:00:00';"
          ) /* ,
          
          'x.x.x' => array ( 
                  // do something
                  1 => ";",
                  // do something else
                  2 => ";"
          )    */
		  
    );  // end: var $version_updates


	// /////////////////////////////
    // END OF USER CONFIGURATION
    // /////////////////////////////



    //
    // Member Vars
    //
	var $version_outofdate = false;
	var $stored_version = 0;
	var $needs_update = false;
	var $found_one = false;
	var $status_messages = '';
	var $connection_type = '';


    /**
     * Class Constructor.
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @param int $fxn - constant defining the function to perform upon construction
     */
    function configurer($fxn = false, $link = 'db_link') {
	  global $$link;

	  // set connection type
	  $this->connection_type = (@mysqli_get_server_info($$link) ? 'mysqli' : 'mysql');
	  
	  // set contribution version
	  $this->stored_version = $this->db_stored_version();
	  $this->version_outofdate = $this->db_version_outofdate();

	  switch ($fxn) {
		case CONFIGURER_CHECK_STATUS:
			   $this->db_configurer_update(CONFIGURER_CHECK_STATUS);
			   break; 
		case CONFIGURER_DISPLAY_UPDATES: 
			   $this->db_configurer_update(CONFIGURER_DISPLAY_UPDATES);
			   break; 
		case CONFIGURER_PROCESS_UPDATES: 
			   $this->db_configurer_update(CONFIGURER_PROCESS_UPDATES);
			   break; 
		case CONFIGURER_REFRESH_CONFIG: 
			   $this->db_configurer_update(CONFIGURER_REFRESH_CONFIG);
			   break; 
	  }

	}

    //
    // Member Functions
    //

    /**
     * Returns a button that links to configurer interface.
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @return returns string with button code.
     */
	function db_configurer_button() {
	  return tep_draw_input_field('configurer', $this->current_version['name'].' '.BUTTON_TITLE, 'class="configurer" style="padding: 0 4px; font-size: 9px; height: 16px;" onclick="window.location.href=\''.tep_href_link('configurer.php','conf='.substr($this->cancel_page,0,-4)).'\'"', false, 'button');
	}


    /**
     * Fetch array uses mysql_ or mysqli_ functions depending on connection opened.
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @param resourse $res - a result set identifier returned by mysql(i)_query()
     * @param int $result_type - parameter is a constant indicating what type of array should be produced MYSQLI_ASSOC, MYSQLI_NUM, or MYSQLI_BOTH
     * @return returns .
     */
    function fetch_array($res, $result_type) {
	  switch ($this->connection_type) {
	    case 'mysqli':
          return mysqli_fetch_array($res, $result_type);
		  break;
	    case 'mysql':
          return mysql_fetch_array($res, $result_type);
		  break;
	  }
    }
	
    /**
     * Gets one row & one column from osCommerce database.
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @param string $query - query string that will return one row, one column
     * @return returns the value derived from database or false if not found.
     */
	function db_get_one_value($query) {
	  $return = false;

	  $res = tep_db_query($query);
	  if ($res && tep_db_num_rows($res)) { 
        tep_db_data_seek($res, 0);
		if ($data = $this->fetch_array($res, MYSQLI_NUM)) {
          $return = $data[0];
		}
	    tep_db_free_result($res);
	  }

	  return $return;
	}

    /**
     * returns the current installed version.
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @return version number stored in database for this contribution, or Zero if not found
     */
    function db_stored_version() {
      if ($col = $this->db_get_one_value('select `configuration_value` from `' . TABLE_CONFIGURATION . "` where `configuration_key` = '" . $this->current_version['configuration_key'] . "' limit 1")) {
		return $col;
      }

      return 0;  // specifically returning Zero, not false
    }

    /**
     * Determines whether the version stored in the database is the same as the version defined in this class.
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @return returns the true or false as to whether the current version is same as version saved in database.
     */
    function db_version_outofdate() {
	  return ($this->current_version['version'] != $this->db_stored_version());
    }

    /**
     * Determines whether the a table exists in an osCommerce database.
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @param string $table - the table we are searching for
     * @return returns either true or false if the table is not found.
     */
    function db_table_exist($table) {
      $found = false;
      $table_query = tep_db_query("SHOW TABLES");
      if (tep_db_num_rows($table_query) > 0) {
        while ($row = $this->fetch_array($table_query, MYSQLI_NUM)) {
          if ($row[0] == $table) {
            $found = true;
            break;
          }
        }
      }
      tep_db_free_result($table_query);

      return $found;
    }

    /**
     * Determines whether the a column exists in a table in an osCommerce database.
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @param string $table - the table in which the column should exist
     * @param string $column - the column we are searching for
     * @return returns the true or false as to whether a table/column exists in database.
     */
    function db_table_column_exist($table, $column) {
      $found = false;
      $columns_query = tep_db_query("SHOW COLUMNS FROM `" . $table . "`;");
      if (tep_db_num_rows($columns_query) > 0) {
        while ($row = $this->fetch_array($columns_query, MYSQLI_NUM)) {
          if ($row[0] == $column) {
            $found = true;
            break;
          }
        }
      }
      tep_db_free_result($columns_query);

      return $found;
    }

    /**
     * Checks status of configuration.
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @return string with all messages generated during status check or update.
     */
    function db_configurer_status() {
      return $this->db_configurer_update(CONFIGURER_CHECK_STATUS);
    }


    /**
     * Checks status, display processes, or perform update for the associated contribution
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @param int $fxn - accepts an integer referred by the associated constants.
     * @return string with all messages generated during status check or update.
     */
    function db_configurer_update($fxn = CONFIGURER_CHECK_STATUS) {
      $this->needs_update = false;
      $this->found_one = false;
      $this->status_messages = '';
      
      if ($fxn == CONFIGURER_REFRESH_CONFIG) {
          $fxn = CONFIGURER_PROCESS_UPDATES;
          $action = 'force';
      }
  
  
      // check tables
      $this->status_messages .= '<br /><font color="gray">'.TEXT_CHECKING_FOR_TABLES.'</font><br />'."\n";
      if (sizeof($this->tables_array) > 0) {
        foreach ($this->tables_array as $tkey => $tables) {
          if ($this->db_table_exist($tables['tablename'])) {
            $this->found_one = true;
            switch ($fxn) {

              case CONFIGURER_CHECK_STATUS: 
                     $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_TABLE_FOUND, $tables['tablename']).'</font><br />'."\n";
                     break; 

              case CONFIGURER_DISPLAY_UPDATES: 
                     $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_TABLE_FOUND_NOTHING_TO_DO, $tables['tablename']).'</font><br />'."\n";
                     break; 

              case CONFIGURER_PROCESS_UPDATES:
                     $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_TABLE_FOUND_DOING_NOTHING, $tables['tablename']).'</font><br />'."\n";
                     break; 
            }
          } else {
            $this->needs_update = true;
			switch ($fxn) {

              case CONFIGURER_CHECK_STATUS: 
                     $this->status_messages .= '&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_TABLE_NOT_FOUND, $tables['tablename']).'</font><br />'."\n";
                     break; 

              case CONFIGURER_DISPLAY_UPDATES: 
                     $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_CREATE_TABLE_NECESSARY, $tables['tablename']).'</font><br />'."\n";
                     $this->status_messages .= sprintf(SQL_DISPLAY, substr_count($tables['create'],"\n")+1, str_replace('    ',' ',$tables['create']));
  
                     if (count($tables['insert'])) {
                       $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.TEXT_TABLE_INSERTS_NECESSARY.'</font><br />'."\n";
                       $inserts_count = 0;
                       $inserts = '';
                       foreach ($tables['insert'] as $ikey => $insert) {
                         $inserts .= $insert . "\n";
                         $inserts_count++;
                       }
                       $this->status_messages .= sprintf(SQL_DISPLAY, $inserts_count, trim($inserts));
                     }
                     break; 

              case CONFIGURER_PROCESS_UPDATES: 
                     $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_TABLE_NOT_FOUND_CREATING, $tables['tablename']).'</font><br />'."\n";
                     if (tep_db_query($tables['create'])) {
                       $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_SUCCESS_CREATING_TABLE, $tables['tablename']).'</font><br />'."\n";
                       foreach ($tables['insert'] as $ikey => $insert) {
                         if (tep_db_query($insert)) {
                           $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="green">+ '.sprintf(TEXT_SUCCESS_INSERTING_INTO_TABLE, tep_db_insert_id(), $tables['tablename'] ).'</font><br />'."\n";
                         } else {
                           $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="red">- '.sprintf(TEXT_ERROR_INSERTING_INTO_TABLE, $tables['tablename']).'</font><br />'."\n";
                         }
                       }
                     } else {
                       $this->status_messages .= '&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_ERROR_CREATING_TABLE, $tables['tablename']).'</font><br />'."\n";
                     }
                     break; 
            }
          }
        }
      } else {
        $this->status_messages .= '&nbsp;&nbsp;<font color="gray">'.TEXT_NO_TABLES.'</font><br />'."\n";
      }
  
  
      // check columns
      $this->status_messages .= '<br /><font color="gray">'.TEXT_CHECKING_FOR_COLUMNS.'</font><br />'."\n";
      if (sizeof($this->table_columns_array) > 0) {
        foreach ($this->table_columns_array as $tkey => $table_mods) {
          // check for table before checking for column
          if ($this->db_table_exist($table_mods['tablename'])) {
            // table found, check for the column
            if ($this->db_table_column_exist($table_mods['tablename'], $table_mods['columnname'])) {
              $this->found_one = true;
              switch ($fxn) {

                case CONFIGURER_CHECK_STATUS: 
                       $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_COLUMN_FOUND, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
                       break; 

                case CONFIGURER_DISPLAY_UPDATES: 
                       $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_COLUMN_FOUND_NOTHING_TO_DO, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
                       break; 

                case CONFIGURER_PROCESS_UPDATES: 
                       $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_COLUMN_FOUND_DOING_NOTHING, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
                       break; 
              }
            } else {
              $this->needs_update = true;
			  switch ($fxn) {

                case CONFIGURER_CHECK_STATUS: 
                       $this->status_messages .= '&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_COLUMN_NOT_FOUND, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
                       break; 

                case CONFIGURER_DISPLAY_UPDATES: 
                       $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_CREATE_COLUMN_NECESSARY, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
                       $this->status_messages .= sprintf(SQL_DISPLAY, 1, $table_mods['create']);
                       break; 

                case CONFIGURER_PROCESS_UPDATES: 
                       $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_COLUMN_NOT_FOUND_CREATING, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
                       if (tep_db_query($table_mods['create'])) {
                         $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_SUCCESS_CREATING_COLUMN, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
                       } else {
                         $this->status_messages .= '&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_ERROR_CREATING_COLUMN, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
                       }
                       break; 
              }
            }
          } else {
            $this->needs_update = true;
            $this->status_messages .= '&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_TABLE_NOT_FOUND_FOR_COLUMN, $table_mods['tablename']).'</font><br />'."\n";
          }
        }
      } else {
        $this->status_messages .= '&nbsp;&nbsp;<font color="gray">'.TEXT_NO_COLUMNS.'</font><br />'."\n";
      }
  
  
      // check configuration table items
      $this->status_messages .= '<br /><font color="gray">'.TEXT_CHECKING_FOR_CONFIGURATION_ITEMS.'</font>'."\n";
      foreach ($this->configuration_array as $tkey => $configuration) {
        $configuration_group_id = $this->db_get_one_value('select configuration_group_id from ' . TABLE_CONFIGURATION_GROUP . " where configuration_group_title = '" . tep_db_input($configuration['group']['configuration_group_title']) . "' limit 1");
        switch ($fxn) {

          case CONFIGURER_CHECK_STATUS: 
                 if ($configuration_group_id) {
                   $this->status_messages .= '<br />&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_CONFIG_GROUP_EXIST, $configuration['group']['configuration_group_title']).'</font><br />&nbsp;&nbsp;<font color="gray">' . TEXT_CHECKING_FOR_KEYS . '</font><br />'."\n";
                   foreach ($configuration['data'] as $configuration_key => $configuration_data) {
                     $configuration_query = tep_db_query('select configuration_id, configuration_title, configuration_value, configuration_description, use_function, set_function from ' . TABLE_CONFIGURATION . " where configuration_key = '" . $configuration_key . "' limit 1");
                     if (tep_db_num_rows($configuration_query) > 0) {
                       $this->found_one = true;
                       $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_CONFIG_KEY_EXIST, $configuration_key).'</font><br />'."\n";
                     } else {
                       $this->needs_update = true;
                       $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_CONFIG_KEY_NOT_EXIST, $configuration_key).'</font><br />'."\n";
                     }
                     tep_db_free_result($configuration_query);
                   }
                 } else {
                   $this->needs_update = true;
                   $this->status_messages .= '<font color="red">'.sprintf(TEXT_CONFIG_GROUP_NOT_EXIST, $configuration['group']['configuration_group_title']).'</font><br />'."\n";
                 }
                 break; 

          case CONFIGURER_DISPLAY_UPDATES: 
                 if ($configuration_group_id) {
				   $this->status_messages .= '<br />&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_UPDATING_CONFIGURATION_GROUP, $configuration['group']['configuration_group_title']).'</font><br />&nbsp;&nbsp;<font color="gray">' . TEXT_CHECKING_FOR_KEYS . '</font><br />'."\n";
                   $use_sort_order = $this->db_get_one_value('select max(sort_order) from `' . TABLE_CONFIGURATION . "` where `configuration_group_id` = '" . $configuration_group_id . "'");
                   $use_sort_order++;
                 } else {
                   $this->needs_update = true;
				   $this->status_messages .= '<br /><font color="green">'.sprintf(TEXT_ADD_CONFIGURATION_GROUP, $configuration['group']['configuration_group_title']).'</font><br />'."\n";
                   $group_sort_order = $this->db_get_one_value('select max(sort_order) from `' . TABLE_CONFIGURATION_GROUP . '`');
                   $group_sort_order++;
                   $configuration_group_id = $this->db_get_one_value('select max(configuration_group_id) from `' . TABLE_CONFIGURATION_GROUP . '`');
                   $configuration_group_id++;
                   $this->status_messages .= sprintf(SQL_DISPLAY, 1, 'insert into `' . TABLE_CONFIGURATION_GROUP . "` (configuration_group_id, configuration_group_title, configuration_group_description, sort_order, visible) VALUES ('".$configuration_group_id."', '".tep_db_input($configuration['group']['configuration_group_title'])."', '".tep_db_input($configuration['group']['configuration_group_description'])."', '".$group_sort_order."', '".$configuration['group']['visible']."');");
                   $use_sort_order = 1;
                 }
  
                 $update_count = 0;
                 foreach ($configuration['data'] as $configuration_key => $configuration_data) {
                     $tconfig_id = $this->db_get_one_value('select configuration_id from `' . TABLE_CONFIGURATION . "` where `configuration_key` = '" . $configuration_key . "' limit 1");
                     if (!$tconfig_id) {
                       $update_count++;
                       $this->needs_update = true;
					   $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_ADD_CONFIGURATION_KEY, $configuration_key).'</font><br />'."\n";
                       $this->status_messages .= sprintf(SQL_DISPLAY, 1, 'insert into ' . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) values ('" . tep_db_input($configuration_data['configuration_title']) . "', '" . $configuration_key . "', " . ($configuration_data['configuration_value']=='now()' ? $configuration_data['configuration_value'] : "'".tep_db_input($configuration_data['configuration_value'])."'") . ", '" . tep_db_input($configuration_data['configuration_description']) . "', " . $configuration_group_id . ", " . $use_sort_order++ . ", now(), " . (!empty($configuration_data['use_function']) ? "'".tep_db_input($configuration_data['use_function'])."'" : "NULL" ) . ", " . (!empty($configuration_data['set_function']) ? "'".tep_db_input($configuration_data['set_function'])."'" : "NULL" ) . ");");
                     } else {
					   $this->found_one = true;
					 }
                 }
				 if ($update_count == 0) {
				   $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="green">' . TEXT_NO_CONFIGURATION_KEY_UPDATES . '</font><br />'."\n";
				 }
                 break; 

          case CONFIGURER_PROCESS_UPDATES: 
                 if ($configuration_group_id) {
                   $this->status_messages .= '<br />&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_UPDATING_CONFIGURATION_GROUP, $configuration['group']['configuration_group_title']).'</font><br />&nbsp;&nbsp;<font color="gray">' . TEXT_CHECKING_FOR_KEYS . '</font><br />'."\n";
                   if ($action == 'force') { // only update group if doing a 'force'
                     tep_db_query('update `' . TABLE_CONFIGURATION_GROUP . "` set `configuration_group_description` = '" . tep_db_input($configuration['group']['configuration_group_description']) . "' where `configuration_group_id` = '" . $configuration_group_id . "' limit 1");
                     $update_count++;
				   }
                   $use_sort_order = $this->db_get_one_value('select max(sort_order) from `' . TABLE_CONFIGURATION . "` where `configuration_group_id` = '" . $configuration_group_id . "'");
                   $use_sort_order++;
                 } else {
                   $this->status_messages .= '<br /><font color="green">'.sprintf(TEXT_ADDING_CONFIGURATION_GROUP, $configuration['group']['configuration_group_title']).'</font><br />'."\n";
                   $group_sort_order = $this->db_get_one_value('select max(sort_order) from `' . TABLE_CONFIGURATION_GROUP . '`');
                   $group_sort_order++;
                   tep_db_query('insert into `' . TABLE_CONFIGURATION_GROUP . "` (configuration_group_title, configuration_group_description, sort_order, visible) VALUES ('".tep_db_input($configuration['group']['configuration_group_title'])."', '".tep_db_input($configuration['group']['configuration_group_description'])."', '".$group_sort_order."', '".$configuration['group']['visible']."')");
                   $update_count++;
                   $configuration_group_id = tep_db_insert_id();
                   $use_sort_order = 1;
                 }
  
                 $update_count = 0;
                 foreach ($configuration['data'] as $configuration_key => $configuration_data) {
                   if ( !(($action == 'force') && ($configuration_key == $this->current_version['configuration_key'])) ) { // if doing a force and the current key is the version number key, don't update it.
                     $configuration_id = $this->db_get_one_value('select configuration_id from `' . TABLE_CONFIGURATION . "` where `configuration_key` = '" . $configuration_key . "' limit 1");
                     if ($configuration_id) {
                       if ($action == 'force') { // only update key if doing a 'force'
                         $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_UPDATING_CONFIGURATION_KEY, $configuration_key).'</font><br />'."\n";
                         tep_db_query('update `' . TABLE_CONFIGURATION . "` set `configuration_title` = '" . tep_db_input($configuration_data['configuration_title']) . "', `configuration_value` = " . ($configuration_data['configuration_value']=='now()' ? $configuration_data['configuration_value'] : "'".tep_db_input($configuration_data['configuration_value'])."'") . ", `configuration_description` = '" . tep_db_input($configuration_data['configuration_description']) . "', `configuration_group_id` = '" . $configuration_group_id . "', `sort_order` = '" . $use_sort_order++ . "', `last_modified` = now(), `use_function` = " . (!empty($configuration_data['use_function']) ? "'".tep_db_input($configuration_data['use_function'])."'" : "NULL" ) . ", `set_function` = " . (!empty($configuration_data['set_function']) ? "'".tep_db_input($configuration_data['set_function'])."'" : "NULL" ) . " where `configuration_id` = '" . $configuration_id . "' limit 1");
                         $update_count++;
                       }
                     } else {
                       $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_ADDING_CONFIGURATION_KEY, $configuration_key).'</font><br />'."\n";
                       tep_db_query('insert into `' . TABLE_CONFIGURATION . "` (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) values ('" . tep_db_input($configuration_data['configuration_title']) . "', '" . $configuration_key . "', " . ($configuration_data['configuration_value']=='now()' ? $configuration_data['configuration_value'] : "'".tep_db_input($configuration_data['configuration_value'])."'") . ", '" . tep_db_input($configuration_data['configuration_description']) . "', " . $configuration_group_id . ", " . $use_sort_order++ . ", now(), " . (!empty($configuration_data['use_function']) ? "'".tep_db_input($configuration_data['use_function'])."'" : "NULL" ) . ", " . (!empty($configuration_data['set_function']) ? "'".tep_db_input($configuration_data['set_function'])."'" : "NULL" ) . ")");
                       $update_count++;
                     }
                   } else {
                     $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_SKIPPING_VERSION_CONFIGURATION_KEY, $configuration_key).'</font><br />'."\n";
                   }
                 }
				 if ($update_count == 0) {
				   $this->status_messages .= '&nbsp;&nbsp;&nbsp;&nbsp;<font color="green">' . TEXT_NO_CONFIGURATION_KEY_UPDATES . '</font><br />'."\n";
				 }
                 break; 
        }
      }
  
  
      // check version updates
      $update_count = 0;
      $update_list = '';
      $this->status_messages .= '<br /><font color="gray">'.TEXT_CHECKING_FOR_VERSION_UPDATES.'</font><br />'."\n";
      if (is_array($this->version_updates) && count($this->version_updates)) {
      
          if ($fxn == CONFIGURER_CHECK_STATUS && empty($this->stored_version)) {
            $this->needs_update = true;
            $this->status_messages .= '&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_NO_VERSION_NUMBER_IN_DATABASE, $this->current_version['name']).'</font><br />'."\n";
          }
          
          foreach ($this->version_updates as $vkey => $updates) {
              if (version_compare($vkey, $this->stored_version, '>')) {
                  foreach ($updates as $ukey => $update) {
                      $update_count++;
                      switch ($fxn) {

                        case CONFIGURER_CHECK_STATUS: 
                               // nothing to do for check.
                               break; 

                        case CONFIGURER_DISPLAY_UPDATES: 
                               // determine if it is a column add, if so, make sure the column doesn't exist before processing.
                               if (preg_match('/ALTER TABLE\s+`*([a-zA-Z0-9_]+)`*\s+ADD\s+`*([a-zA-Z0-9_]+)`*/i', $update, $matches)) {
                                 if (!$this->db_table_exist($matches[1]) || !$this->db_table_column_exist($matches[1], $matches[2])) {
                                   $update_list .= $update . "\n";
                                 }
                               } else {
                                 $update_list .= $update . "\n";
                               }
                               break; 

                        case CONFIGURER_PROCESS_UPDATES: 
                               // determine if it is a column add, if so, make sure the column doesn't exist before processing.
                               if (preg_match('/ALTER TABLE\s+`*([a-zA-Z0-9_]+)`*\s+ADD\s+`*([a-zA-Z0-9_]+)`*/i', $update, $matches)) {
                                 if ($this->db_table_exist($matches[1])) {
                                   if (!$this->db_table_column_exist($matches[1], $matches[2])) {
                                     tep_db_query($update);
                                   }
                                 }
                               } else {
                                 tep_db_query($update);
                               }
                               break; 
                      }
                  }
              }
          }
  
          if ($update_count) {
			  $this->needs_update = true;
              switch ($fxn) {

                case CONFIGURER_CHECK_STATUS: 
                       if (!empty($this->stored_version)) {
                         $this->status_messages .= '&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_VERSION_UPDATES_ARE_NECESSARY, $update_count, $this->current_version['name'] . ' v' . $this->stored_version).'</font><br />'."\n";
                       }
                       break; 

                case CONFIGURER_DISPLAY_UPDATES: 
                       $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.TEXT_VERSION_UPDATES_NECESSARY.'</font><br />'."\n";
                       $this->status_messages .= sprintf(SQL_DISPLAY, $update_count, trim($update_list));
                       break; 

                case CONFIGURER_PROCESS_UPDATES: 
                       $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_VERSION_UPDATES_PERFORMED, $update_count, $this->current_version['name'] . ' v' . $this->current_version['version']).'</font><br />'."\n";
                       break; 
              }
          }
      }
      if ($update_count == 0) {
          $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_NO_VERSION_UPDATES_NECESSARY, $this->current_version['name']).'</font><br />'."\n";
      }
  
      switch ($fxn) {

        case CONFIGURER_CHECK_STATUS: 
               // nothing to do but return the status messages, below.
			   break; 
  
        case CONFIGURER_DISPLAY_UPDATES: 
               // as the finally, set the version number in the database.
               if (version_compare($this->current_version['version'], $this->stored_version, '!=')) {
                 $this->status_messages .= '<br /><font color="green">'.sprintf(TEXT_SET_VERSION_NUMBER,$this->current_version['version']).'</font><br />'."\n";
                 $this->status_messages .= sprintf(SQL_DISPLAY, 1, 'update ' . TABLE_CONFIGURATION . " set configuration_value = '" . tep_db_input($this->current_version['version']) . "' where configuration_key = '" . $this->current_version['configuration_key'] . "';");
               }
               break; 
  
        case CONFIGURER_PROCESS_UPDATES: 
               // as the finally, set the version number in the database.
               if (version_compare($this->current_version['version'], $this->stored_version, '!=')) {
                 $this->status_messages .= '<br /><font color="green">'.sprintf(TEXT_SETTING_VERSION_NUMBER,$this->current_version['version']).'</font><br />'."\n";
                 
				 tep_db_query('update ' . TABLE_CONFIGURATION . " set configuration_value = '" . tep_db_input($this->current_version['version']) . "' where configuration_key = '" . $this->current_version['configuration_key'] . "'");
				 
				 $this->stored_version = $this->db_stored_version();
				 $this->version_outofdate = $this->db_version_outofdate();
               }
               break; 
      }

      return $this->status_messages;
    } // end: db_configurer_update()


    /**
     * Uninstalls the associated contribution
     * 
     * @author Todd Holforty [surfalot] <mtholforty [at] surfalot [dot] com>
     * @return string with all messages generated during remove.
     */
    function db_configurer_remove() {
		$this->status_messages = '';

		// remove columns
		$this->status_messages .= '<br /><font color="gray">'.TEXT_CHECKING_FOR_COLUMNS_REMOVE.'</font><br />'."\n";
		if (sizeof($this->table_columns_array) > 0) {
		  foreach ($this->table_columns_array as $tkey => $table_mods) {
			  if ($this->db_table_exist($table_mods['tablename'])) {
				  if ($this->db_table_column_exist($table_mods['tablename'], $table_mods['columnname'])) {
					$this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_COLUMN_FOUND_REMOVING, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
					if (tep_db_query($table_mods['remove'])) {
					  $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_SUCCESS_REMOVING_COLUMN, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
					} else {
					  $this->status_messages .= '&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_ERROR_REMOVING_COLUMN, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
					}
				  } else {
					$this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_COLUMN_NOT_FOUND_DOING_NOTHING, $table_mods['columnname'], $table_mods['tablename']).'</font><br />'."\n";
				  }
			  } else {
				$this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_TABLE_FOUND_NOT_PROCESSING, $table_mods['tablename']).'</font><br />'."\n";
			  }
		  }
		} else {
		  $this->status_messages .= '&nbsp;&nbsp;<font color="gray">'.TEXT_NO_COLUMNS.'</font><br />'."\n";
		}

		// remove tables
		$this->status_messages .= '<br /><font color="gray">'.TEXT_CHECKING_TABLES.'</font><br />'."\n";
		if (sizeof($this->tables_array) > 0) {
		  foreach ($this->tables_array as $tkey => $tables) {
			  if ($this->db_table_exist($tables['tablename'])) {
				$this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_TABLE_FOUND_REMOVING, $tables['tablename']).'</font><br />'."\n";
				if (tep_db_query($tables['remove'])) {
				  $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_SUCCESS_REMOVE_TABLE, $tables['tablename']).'</font><br />'."\n";
				} else {
				  $this->status_messages .= '&nbsp;&nbsp;<font color="red">'.sprintf(TEXT_ERROR_REMOVING_TABLE, $tables['tablename']).'</font><br />'."\n";
				}
			  } else {
				$this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_TABLE_NOT_FOUND_DOING_NOTHING, $tables['tablename']).'</font><br />'."\n";
			  }
		  } 
		} else {
		  $this->status_messages .= '&nbsp;&nbsp;<font color="gray">'.TEXT_NO_TABLES.'</font><br />'."\n";
		}

		// remove configuration table entries
		$this->status_messages .= '<br /><font color="gray">'.TEXT_CHECKING_CONFIGURATION.'</font><br />'."\n";
		foreach ($this->configuration_array as $tkey => $configuration) {

		  $this->status_messages .= '&nbsp;<font color="green">'.sprintf(TEXT_REMOVING_CONFIGURATION_GROUP, $configuration['group']['configuration_group_title']).'</font><br />'."\n";

		  // remove keys
		  foreach ($configuration['data'] as $configuration_key => $configuration_data) {
			$configuration_id = $this->db_get_one_value('select configuration_id from `' . TABLE_CONFIGURATION . "` where `configuration_key` = '" . $configuration_key . "' limit 1");
			if ($configuration_id) {
			  $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_REMOVING_CONFIGURATION_KEY, $configuration_key).'</font><br />'."\n";
			  tep_db_query('delete from `' . TABLE_CONFIGURATION . "` where `configuration_key` = '" . $configuration_key . "' limit 1");
			} else {
			  $this->status_messages .= '&nbsp;&nbsp;<font color="green">'.sprintf(TEXT_ERROR_CONFIGURATION_KEY_NOT_EXIST, $configuration_key).'</font><br />'."\n";
			}
		  }

		  // remove groups if empty
		  $configuration_group_id = $this->db_get_one_value('select `configuration_group_id` from `' . TABLE_CONFIGURATION_GROUP . "` where `configuration_group_title` = '" . $configuration['group']['configuration_group_title'] . "' limit 1");
		  $total_configurations = $this->db_get_one_value('select count(*) as total from `' . TABLE_CONFIGURATION . "` where `configuration_group_id` = '" . $configuration_group_id . "'");
		  if ($total_configurations < 1) {
			if (tep_db_query('delete from `' . TABLE_CONFIGURATION_GROUP . "` where `configuration_group_id` = '" . $configuration_group_id . "' limit 1")) {
			  $this->status_messages .= '&nbsp;<font color="green">'.sprintf(TEXT_SUCCESS_REMOVE_GROUP, $configuration['group']['configuration_group_title']).'</font><br /><br />'."\n";
			} else {
			  $this->status_messages .= '&nbsp;<font color="red">'.sprintf(TEXT_ERROR_REMOVING_GROUP, $configuration['group']['configuration_group_title']).'</font><br /><br />'."\n";
			}
		  } else {
			$this->status_messages .= '&nbsp;<font color="red">'.sprintf(TEXT_GROUP_NOT_EMPTY, $configuration['group']['configuration_group_title']).'</font><br /><br />'."\n";
		  }

		}
		
		return $this->status_messages;
    } // end: db_configurer_remove()


} // end: class

?>